﻿using SMP.Model;
using SMP.Model.Compute;
using XYY.Core.Standard.Data.Infrastructure;

namespace SMP.Data.Compute
{
    public interface ICompute_ExpenseRepository : IBaseRepository<Compute_Expense>
    {
        Task<IEnumerable<Compute_Expense>> GetServiceProviderExpense(int resolveSolutionId);
    }

    public class Compute_ExpenseRepository : BaseRepository<Compute_Expense>, ICompute_ExpenseRepository
    {
        public Compute_ExpenseRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public async Task<IEnumerable<Compute_Expense>> GetServiceProviderExpense(int resolveSolutionId)
        {
            string sql = "select e.* from Compute_Expense e inner join Finance_ServiceBillResolveSolution s on s.ServiceProviderId=e.ServiceProviderId where s.Id=@Id";
            var result =await QueryBySqlAsync(sql, new { Id = resolveSolutionId });
            return result;
        }
    }
}