﻿using RestSharp;
using SMP.Service.BaseInfo.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.BaseInfo
{
    public interface IBaseInfoService
    {
        Task<List<CustomerDto>> GetAllCustomers();
        Task<List<PublicChannelDto>> GetAllPublicChannels();
        Task<List<DeliveryChannelDto>> GetAllDeliveryChannels();
    }

    public class BaseInfoService : IBaseInfoService
    {
        private string token = "132A7468DE079C6CEB59F383A661E612";
        private string host = "http://wms.xingyunyi.cn";

        public async Task<List<CustomerDto>> GetAllCustomers()
        {
            var resp = await Request<ApiResult<List<CustomerDto>>>("/api/BaseInfo/GetCustomers");
            return resp.Data;
        }

        public async Task<T> Request<T>(string api)
        {
            RestClient client = new RestClient(host);
            RestRequest request = new RestRequest(api);

            Parameter tokenParam = new HeaderParameter("Token", token);
            request.AddParameter(tokenParam);

            var resp = await client.GetAsync<T>(request);
            return resp;
        }

        public async Task<List<DeliveryChannelDto>> GetAllDeliveryChannels()
        {
            var resp = await Request<ApiResult<List<DeliveryChannelDto>>>("/api/BaseInfo/GetDeliverChannel");
            return resp.Data;
        }

        public async Task<List<PublicChannelDto>> GetAllPublicChannels()
        {
            var resp = await Request<ApiResult<List<PublicChannelDto>>>("/api/BaseInfo/GetAllPublic");
            return resp.Data;
        }
    }
}
