﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.ServiceBillResolve
{
    public class ServiceBillResolverFactory
    {
        private static object syncRoot = new object();

       private static IServiceBillResover feeListResolver = null;
       private static IServiceBillResover numberListResolver = null;
        public static IServiceBillResover GetBillResover(BillListingStyle ruleType)
        {
            lock (syncRoot)
            {
                if (ruleType == BillListingStyle.FeeList)
                {
                    if (feeListResolver == null)
                        feeListResolver = new FeeListModeResolver();

                    return feeListResolver;
                }
                else
                {
                    if (numberListResolver == null)
                        numberListResolver = new NumberListModeResolver();

                    return numberListResolver;
                }
            }
        }
    }
}
